<h4>Alerts Search</h4>
<hr>
<!-- Databases -->
<div class="input-group mb-3">
    <div class="input-group-prepend">
        <span class="input-group-text">Databases</span>
    </div>
    <select class="form-control" [ngModel]="selectedDb" (ngModelChange)="updateTableNames($event)" [disabled]="!isNeonReady">
        <option [ngValue]="null" disabled selected="true">—</option>
        <option *ngFor="let dbName of dbNames" [ngValue]="dbName">{{ dbName }}</option>
    </select>
</div>
<!-- Tables -->
<div class="input-group mb-3">
    <div class="input-group-prepend">
        <span class="input-group-text">Tables</span>
    </div>
    <select class="form-control" [ngModel]="selectedTable" (ngModelChange)="updateFieldNames($event)" [disabled]="!this.tableNames.length || !isNeonReady">
        <option [ngValue]="null" disabled selected>—</option>
        <option *ngFor="let tableName of tableNames" [ngValue]="tableName">{{ tableName }}</option>
    </select>
</div>
<h5>Date Range </h5>
<table class="table table-bordered">
    <thead>
        <tr>
            <th class="col-xs-4">Date Field</th>
            <th>From</th>
            <th>To</th>
        </tr>
    </thead>
    <tbody>
        <tr>
            <td>
                <select class="form-control" [(ngModel)]="selectedTimeFilterField" [disabled]="!hasFields()">
                    <option [ngValue]="null" disabled>—</option>
                    <option *ngFor="let fieldName of fieldNames" [value]="fieldName">{{ fieldName }}</option>
                </select>
            </td>
            <td>
                <input type="text" [(ngModel)]="selectedTimeFilterFrom" placeholder="From Date" class="form-control" bsDatepicker [bsConfig]="bsConfig"
                    [disabled]="!hasFields()">
            </td>
            <td>
                <input type="text" [(ngModel)]="selectedTimeFilterTo" placeholder="To Date" class="form-control" bsDatepicker [bsConfig]="bsConfig"
                    [disabled]="!hasFields()">
            </td>
        </tr>
    </tbody>
</table>
<hr>
<h5>Source IP</h5>
<table class="table table-bordered">
    <thead>
        <tr>
            <th class="col-xs-4">Source Field</th>
            <th>Source</th>
        </tr>
    </thead>
    <tbody>
        <tr>
            <td>
                <select class="form-control" [(ngModel)]="selectedSourceIpField" [disabled]="!hasFields()">
                    <option [ngValue]="null" disabled>—</option>
                    <option *ngFor="let fieldName of fieldNames" [value]="fieldName">{{ fieldName }}</option>
                </select>
            </td>
            <td>
                <input type="text" [(ngModel)]="sourceIP" (ngModelChange)="resetFilters()" placeholder="127.0.0.1" class="form-control" [disabled]="!hasFields()">
            </td>
        </tr>
    </tbody>
</table>
<h5>Target IP</h5>
<table class="table table-bordered">
    <thead>
        <tr>
            <th class="col-xs-4">Target Field</th>
            <th>Target</th>
        </tr>
    </thead>
    <tbody>
        <tr>
            <td>
                <select class="form-control" [(ngModel)]="selectedTargetIpField" [disabled]="!hasFields()">
                    <option [ngValue]="null" disabled>—</option>
                    <option *ngFor="let fieldName of fieldNames" [value]="fieldName">{{ fieldName }}</option>
                </select>
            </td>
            <td>
                <input type="text" [(ngModel)]="targetIP" placeholder="127.0.0.1" class="form-control" [disabled]="!hasFields()">
            </td>
        </tr>
    </tbody>
</table>
<h5>Detector and Category</h5>
<table class="table table-bordered">
    <thead>
        <tr>
            <th class="col-xs-4">Detector</th>
            <th>Category</th>
        </tr>
    </thead>
    <tbody>
        <tr>
            <td>
                <select class="form-control" [(ngModel)]="selectedDetector" (ngModelChange)="resetFilters()" [disabled]="!hasFields()">
                    <option [ngValue]="null" disabled>—</option>
                    <option *ngFor="let detector of detectors" [value]="detector">{{ detector }}</option>
                </select>
            </td>
            <td>
                <select class="form-control" [(ngModel)]="selectedCategory" (ngModelChange)="resetFilters()" [disabled]="!hasFields()">
                    <option [ngValue]="null" disabled>—</option>
                    <option *ngFor="let category of categories" [value]="category">{{ category }}</option>
                </select>
            </td>
        </tr>
    </tbody>
</table>
<!-- Date Filtering -->

<h5>Limit</h5>
<select class="form-control" [(ngModel)]="selectedLimit" [disabled]="!canSendQuery()">
    <option value="100">100</option>
    <option value="1000">1,000</option>
    <option value="5000">5,000</option>
    <option value="10000">10,000</option>
    <option value="50000">50,000</option>
</select>
<hr>
<div>
    <tabset>
        <tab heading="Results Table" id="tab1" [disabled]="!lastResponse">
            <hr>
            <h4>Result Table</h4>
            <div class="container-fluid" *ngIf="tableData">
                <div>
                    <div class="table-wrapper-2">
                        <div class="input-group mb-3">
                            <input type="text" class="form-control" name="search" [(ngModel)]="term" placeholder="Table Search" aria-label="Recipient's username"
                                aria-describedby="basic-addon2">
                            <div class="input-group-append">
                                <span class="input-group-text" id="basic-addon2">Search</span>
                            </div>
                        </div>
                        <table class="table table-responsive-md">
                            <thead class="mdb-color lighten-4">
                                <tr>
                                    <th class="th-lg">Time Created</th>
                                    <th class="th-lg">Source Country</th>
                                    <th class="th-lg">Source IP</th>
                                    <th class="th-lg">Target IP</th>
                                    <th class="th-lg">Category</th>
                                    <th class="th-lg">Description</th>
                                    <th class="th-lg">Protocol</th>
                                    <th class="th-lg">Detector</th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr *ngFor="let row of tableData | filter:term | paginate: { itemsPerPage: 4, currentPage: p }; let i = index">
                                    <td>{{row.time}}</td>
                                    <td>{{row.country}}</td>
                                    <td>{{row.sourceIp}}</td>
                                    <td>{{row.targetString}}</td>
                                    <td>{{row.categ}}</td>
                                    <td>{{row.desc}}</td>
                                    <td>{{row.protoString}}</td>
                                    <td>{{row.nodeNames}}</td>
                                </tr>
                            </tbody>
                        </table>
                        <pagination-controls maxSize="5" (pageChange)="p = $event"></pagination-controls>
                    </div>
                    <br>
                    <!-- <div class="input-group">
                        <div>
                            <input type="text" ([ngModel])="outputFileName" placeholder="Enter a name for the file">
                        </div>
                        <div class="input-group-append">
                            <button class="btn btn-primary" (click)="downloadDataFile()" [disabled]="!lastResponse">
                                Download CSV File
                            </button>
                        </div>
                    </div> -->
                    <div class="input-group mb-3">
                        <input type="text" class="form-control" name="enterFileName" [(ngModel)]="outputFileName" placeholder="Enter a name for the file" aria-label="File Name"
                            aria-describedby="basic-addon2">
                        <div class="input-group-append">
                            <button class="btn btn-primary" (click)="downloadDataFile()" [disabled]="!tableData">
                                Download CSV File
                            </button>
                        </div>
                    </div>
                    <br>
                </div>
            </div>
        </tab>
        <tab heading="Raw Results (takes time ...)">
            <hr>
            <h4>Raw Results</h4>
            <textarea class="form-control" rows="8" placeholder="Response..." [disabled]="!selectedTable">{{ lastResponse | json }}</textarea>
        </tab>
    </tabset>
</div>
<br>
<button class="btn btn-block btn-success" (click)="sendQuery()" [disabled]="!canSendQuery()" *ngIf="isNeonReady">
    Send Query
    <i class="fa fa-spinner fa-spin" *ngIf="processing"></i>
</button>
<br>
